PROGRAM BenchMark;

{$I Speed.INC}

USES
   opCrt, OPDOS, OPSTRING, ProcGlobal
   {$IFDEF ResetTimerSpeed}
   ,SPEED
   {$ENDIF};

CONST
   NumLoops = 1000;
   sArray = 55;
   NumTmp =30;

Type
   RecordBench = record
                     a : array [1..115] of byte;
                     r : array [1..115] of Real;
                  end;

   shstr = array [1..15000] of BYTE;

VAR
   NUMREAD, NUMWRT, I, i1, L, N :word;
   J, K, tk : Longint;
   tarr : array [1..sarray] of RecordBench;
   Timer    : Longint absolute 0:$46C;
   TimerOld, TimerSav, TimerSav1, TimerSav2 : Double;
   InFile, OutFile : File;
   S1, S2  : String;
   buf : SHstr;
   SaveY : Byte;
   H, M, Sec : Byte;

procedure Abort(S : String);
      var
         i : Integer;
   begin
      WriteLn(S);
      i := ioResult;
      if i = 0 then i := 1;
      Halt(i);
   end;

procedure tmp;
   var
      j,k,l:longint;
      h1,h2, m1,m2, s1,s2, d1,d2 : Word;
      i,is,t1,t2,xtime,pl:longint;
      ss,ps:single;
      dd,pd:double;
      a,b,c: array[0..15,0..15] of single;
      x,y,z: array[0..15,0..15] of double;
      d,e,f: array[0..15,0..15] of longint;
      s,t: array[0..15] of string;

   const
      st : string ='  ';

   begin

      ps:=3.1425;
      pd:=3.1425;
      pl:=31425;

      for j:=1 to 15  do begin
         t[j]:=st+st;
         for k:=1 to 15 do
         begin
            ss:=j+exp(k);
            dd:=ss;
            b[j,k]:=ss;
            c[j,k]:=b[j,k]-j;
            y[j,k]:=dd;
            z[j,k]:=b[j,k]-j;
            e[j,k]:=j+k;
            f[j,k]:=j+k;
         end;
      end;

      for j:=1 to 15 do
      for k:=1 to 15 do
         begin
         if  (b[j,k]>2e15) or (c[j,k] > 2e15) or  (y[j,k] > 2e15) or (z[j,k] > 2e15)
            then Abort(' ');
         end;

      for j:=1 to 15 do  begin
         for k:=1 to 15 do   begin
            a[j,k]:=b[j,k]*c[j,k]+c[j,k]/ps;
            a[j,k]:=b[j,k]*c[j,k]+c[j,k]/ps;
            a[j,k]:=b[j,k]*c[j,k]+c[j,k]/ps;
            a[j,k]:=b[j,k]*c[j,k]+c[j,k]/ps;
            a[j,k]:=b[j,k]*c[j,k]+c[j,k]/ps;
         end;
      end;

      for j:=1 to 15 do begin
         for k:=1 to 15 do begin
            x[j,k]:=y[j,k]*z[j,k]+z[j,k]/pd;
            x[j,k]:=y[j,k]*z[j,k]+z[j,k]/pd;
            x[j,k]:=y[j,k]*z[j,k]+z[j,k]/pd;
            x[j,k]:=y[j,k]*z[j,k]+z[j,k]/pd;
            x[j,k]:=y[j,k]*z[j,k]+z[j,k]/pd;
         end;
      end;

      for j:=1 to 15 do  begin
         s[j]:=t[j];
         s[j]:=t[j]+t[16-j];
         s[j]:=t[j];
         s[j]:=t[j]+t[16-j];
         s[j]:=t[j];
         s[j]:=t[j]+t[16-j];
         s[j]:=t[j];
         s[j]:=t[j]+t[16-j];
         s[j]:=t[j];
         s[j]:=t[j]+t[16-j];
      end;

      for j:=1 to 15 do  begin
         for k:=1 to 15 do   begin
            d[j,k]:=e[j,k]*f[j,k]+(f[j,k] div pl);
            d[j,k]:=e[j,k]*f[j,k]+(f[j,k] div pl);
            d[j,k]:=e[j,k]*f[j,k]+(f[j,k] div pl);
            d[j,k]:=e[j,k]*f[j,k]+(f[j,k] div pl);
            d[j,k]:=e[j,k]*f[j,k]+(f[j,k] div pl);
         end;
      end;

   end;

procedure GetBIOStime(var H, M, Sec : Byte);
   {Get H : M : Sec in hex format from BIOS real time clock}
   begin
      asm
         mov   ah, 2 {Get time func}
         int   $1A   {BIOS real time service}
         les   di, H
         mov   es:[di], ch
         les   di, M
         mov   es:[di], cl
         les   di, Sec
         mov   es:[di], dh
      end;
   end;

BEGIN

   ReInitCrt;
   WriteLn;
   IF EXECDOS('echo '+'Chaikin BenchMark, (C) 1996 CIRC', TRUE, NOEXECDOSPROC) = 0
      THEN;
   WriteLn;
   IF EXECDOS('echo '+'!!! ---- Press any key to stop ---- !!!', TRUE, NOEXECDOSPROC) = 0
      THEN;
   WriteLn;
   WriteLn('                     Memory operations  ');
   WriteLn;
   WriteLn;

   SaveY := WhereYabs-1;

   randomize;
   N := 0;
   TimerSav := 0;

   {$IFDEF ResetTimerSpeed}
   ResetTimerSpeed(True);
   {$ENDIF};
   repeat

      TimerOld := Timer;

      FOR I := 1 TO sarray DO
         with tarr[i] do
            for j := 1 to 200 do a[j] := random(100)+2;

      for i := 1 to NumLoops do begin
         k := random(sarray-10)+5;
         tk := random(50)+1;
         with tarr[k] do
            for j := 1 to 140 do begin
               a[j] := (a[j] div (a[abs(50-j)+1] mod 70 +12))*(a[tk]) mod 90 + 2;
               a[j] := (a[j] div (a[abs(30-j)+1] mod 55 +12))*(a[tk]) mod 30 + 2;
               a[j] := (a[j] div (a[abs(20-j)+1] mod 17 +12))*(a[tk]) mod 9 + 2;
               a[j] := (a[j] div (a[abs(40-j)+1] mod 7 +12))*(a[tk]) mod 190 + 2;
               a[j] := (a[j] div (a[abs(10-j)+1] mod 170 +12))*(a[tk]) mod 90 + 2;
            end;
      end;

      for i := 1 to NumTmp do tmp;

      TimerSav2 := Timer;
      TimerSav2 := TimerSav2-TimerOld;
      TimerSav := (TimerSav2 + n*TimerSav) / (n+1);
      Inc(n);
      FastText (' Step: '+long2str(n)
      +'     Current: '+real2str((NormalMemTime/TimerSav2*24)/6.57,7,2)
      +'      Average: '+real2str((NormalMemTime/TimerSav*24)/6.57,11,2)
      , SaveY, 5);

   until (keypressed);
   i := ord(readkey);

   TimerSav1 := (NormalMemTime*20)/TimerSav;

   {$IFDEF ResetTimerSpeed}
   ResetTimerSpeed(False);
   {$ENDIF};

   GetBIOStime(H, M, Sec);
   IF EXECDOS('time ' +HexB(H)+':'+HexB(M)+':'+HexB(Sec)+' > nul', TRUE, NOEXECDOSPROC) = 0
      THEN;

   WriteLn;
   WriteLn('                   Float points operations');
   WriteLn;
   WriteLn;

   SaveY := WhereYabs-1;

   N := 0;
   TimerSav := 0;

   {$IFDEF ResetTimerSpeed}
   ResetTimerSpeed(True);
   {$ENDIF};
   repeat

      TimerOld := Timer;

      FOR I := 1 TO sarray DO
         with tarr[i] do
            for j := 1 to 55 do r[j] := random(300) / (random(200)+6) + 4;

      for i := 1 to NumLoops do begin
         k := random(sarray-10)+3;
         with tarr[k] do
            for j := 1 to 20 do
               r[j] := (sin(exp(cos(exp((r[j] / 100) / 200)) - cos(r[j]))) / (r[6] + 4) + 2) * (r[8]/200);
      end;

      TimerSav2 := Timer;
      TimerSav2 := TimerSav2-TimerOld;
      TimerSav := (TimerSav2 + n*TimerSav) / (n+1);
      Inc(n);
      FastText (' Step: '+long2str(n)
      +'     Current: '+real2str((NormalMemTime/TimerSav2*24)/11.49,7,2)
      +'      Average: '+real2str((NormalMemTime/TimerSav*24)/11.49,11,2)
      , SaveY, 5);

   until (keypressed);
   i := ord(readkey);

   TimerSav1 := TimerSav1 + NormalMemTime/TimerSav*10;

   {$IFDEF ResetTimerSpeed}
   ResetTimerSpeed(False);
   {$ENDIF};

   GetBIOStime(H, M, Sec);
   IF EXECDOS('time ' +HexB(H)+':'+HexB(M)+':'+HexB(Sec)+' > nul', TRUE, NOEXECDOSPROC) = 0
      THEN;

   WriteLn;
   WriteLn('                  Disk operations');
   WriteLn;
   WriteLn;

   SaveY := WhereYabs-1;
   N := 0;
   TimerSav := 0;

   {$IFDEF ResetTimerSpeed}
   ResetTimerSpeed(True);
   {$ENDIF};
   repeat


      TimerOld := Timer;

      for i1:=1 to 10 do begin

      s1 := long2str((random(150)+6)*(random(400)+6))+'.tmp';
      s2 := long2str((random(300)+6)*(random(200)+6))+'.tmp';

      for i := 1 to 250 do buf [i] := random(200);

      Assign(OutFile, S1); Rewrite(OutFile, 1);
      if ioResult <> 0 then
         Abort('Can''t open '+ S1);

      for j := 1 to 50 do
         BlockWrite(OUTFile, BUF, 250, NUMWRT);
      Close(OutFile);

      Assign(InFile, S1); Reset(InFile, 1);
      if ioResult <> 0 then
         Abort('Can''t open '+ S1);

      Assign(OutFile, S2); Rewrite(OutFile, 1);
      if ioResult <> 0 then
         Abort('Can''t open '+ S2);

      l := 0;
      repeat
         seek(InFile, 5*random(1000)+1);
         i := random(300)+5;
         BlockRead (InFile, BUF[L], i, NUMREAD);
         BlockWrite(OUTFile, BUF[l], i, NUMWRT);
         l := l + i;
      until (l > 11000);

      Close(InFile); Close(OutFile);

      IF EXECDOS('del '+s1+' > nul', TRUE, NOEXECDOSPROC) = 0
         THEN;
      IF EXECDOS('del '+s2+' > nul', TRUE, NOEXECDOSPROC) = 0
         THEN;

      Assign(OutFile, S1); Rewrite(OutFile, 1);
      if ioResult <> 0 then
         Abort('Can''t open '+ S1);

      for j := 1 to 50 do
         BlockWrite(OUTFile, BUF, 250, NUMWRT);
      Close(OutFile);

      Assign(InFile, S1); Reset(InFile, 1);
      if ioResult <> 0 then
         Abort('Can''t open '+ S1);

      Assign(OutFile, S2); Rewrite(OutFile, 1);
      if ioResult <> 0 then
         Abort('Can''t open '+ S2);

      l := 0;
      repeat
         seek(InFile, 5*random(1000)+1);
         i := random(300)+5;
         BlockRead (InFile, BUF[L], i, NUMREAD);
         BlockWrite(OUTFile, BUF[l], i, NUMWRT);
         l := l + i;
      until (l > 11000);

      Close(InFile); Close(OutFile);

      IF EXECDOS('del '+s1+' > nul', TRUE, NOEXECDOSPROC) = 0
         THEN;
      IF EXECDOS('del '+s2+' > nul', TRUE, NOEXECDOSPROC) = 0
         THEN;


      end;

      TimerSav2 := Timer;
      TimerSav2 := TimerSav2-TimerOld;
      TimerSav := (TimerSav2 + n*TimerSav) / (n+1);
      Inc(n);

      FastText (' Step: '+long2str(n)
      +'     Current: '+real2str((NormalDiskTime/TimerSav2*14)/3.905,7,2)
      +'      Average: '+real2str((NormalDiskTime/TimerSav*14)/3.905,11,2)
      , SaveY, 5);

   until (keypressed);
   i := ord(readkey);

   {$IFDEF ResetTimerSpeed}
   ResetTimerSpeed(False);
   {$ENDIF};

   GetBIOStime(H, M, Sec);
   IF EXECDOS('time ' +HexB(H)+':'+HexB(M)+':'+HexB(Sec)+' > nul', TRUE, NOEXECDOSPROC) = 0
      THEN;

   TimerSav1 := TimerSav1*0.7 + ((NormalDiskTime/TimerSav)*14*2)/3;

   WriteLn;
   IF EXECDOS('echo '+'   Average PC index = '+real2str((TimerSav1)/9.8,9,1), TRUE, NOEXECDOSPROC) = 0
      THEN;

END.
